def fn set_colours% (force_mode%)
rem this sets colour variables according to the colour mode wished, if possible.
rem force_mode%=
rem	0 if ql colours wished (mode 4 only)
rem	1 if pal colours wished
rem	2 if 24 bit colours wished
rem This function returns the true QL mode set (4,8,32,33 etc.).
rem This function also sets the GLOBAL variable mycolour_mode% to the
rem mode 0,1,2 as above - whatever is possible on the machine, i.e.
rem if colour_24 is wished on a 4 colour machine (which won't succeed)
rem this function will set set that variable to 0, i.e. QL mode.
rem
rem This function needs the outptr toolkit
local mode%
  mode%=rmode				: rem get current mode now
  select on force_mode%
      = 0				: rem mode 4 wished
       select on mode%
	  = 4				: rem already on, so do nothing
	  = 0,1,8 : mode 4		: rem old modes, set to 4 colours
	  = remainder
	    colour_ql			: rem if higher colour mode, set to "mode 4"
	    mode 4
       end select
       mode%=0				: rem new mode we're in  - 4 colour mode
      = 1				: rem PALette wished
       select on mode%
	  = 16,32,33 : colour_pal:mode%=1  : rem we're in high colour mode, but PAL colours wished
	  = remainder
	    if mode%<>4:mode 4
	    mode%=0
       end select
      = 2
       select on mode%
	  = 32,33 : colour_24 :mode%=2	: rem we're in high col mode 24 bit colours
	  = 16 : colour_pal : mode%=1
	  = remainder
	    if mode%<>4:mode 4
	    mode%=0
       end select
  end select
  mycolour_mode%=mode%			: rem set this global variable now:
  rem now set some colour variables
  select on mode%
       = 0				: rem Ql 4 mode colours
	Black	       = 0
	White	       = 7
	Red	       = 2
	Green	       = 4
	grey	       = 255
	dull_pink      = 19
	Blue	       = 0
	Magenta        = 2
	Yellow	       = 7
	Cyan	       = 0
	Dark_slate     = 0
	Slate_grey     = 255
	Dark_grey      = 255
	Light_grey     = 255
	Ash_grey       = 255
	Dark_red       = 210
	Light_green    = 220
	Mustard        = 242
	Dark_green     = 228
	Sea_blue       = 0
	Dark_blue      = 0
	Purple	       = 0
	Shocking_pink  = 234
	Orange	       = 234
	Lime_green     = 4
	Apple_green    = 4
	Bright_blue    = 0
	Mauve	       = 0
	Peach	       = 7
	Light_yellow   = 7
	Light_blue     = 0
	Sky_blue       = 0
	Rose_pink      = 234
	Pink	       = 234
	Beige	       = 7
	Pastel_pink    = 234
	Pastel_yellow  = 7
	Pastel_green   = 4
	Pastel_cyan    = 0
	Pastel_blue    = 0
	Pastel_rose    = 234
	Brick	       = 210
	Light_khaki    = 7
	Dull_green     = 228
	Dull_cyan      = 0
	Steel_blue     = 0
	Dull_pink      = 234
	Brown	       = 0
	Khaki	       = 7
	Dusky_green    = 4
	Dusky_blue     = 0
	Midnight_blue  = 0
	Plum	       = 0
	Dusky_pink     = 234
	Buff	       = 0
	Avocado        = 4
	Dull_turquoise = 4
	Dull_blue      = 0
	Faded_purple   = 234
	Cerise	       = 2
	Tan_normal     = 0
	Grass_green    = 4
	Sea_green      = 4
	Ultramarine    = 0
	Deep_purple    = 234
	Light_orange   = 7
	light_red      = 2
	wg_striped     = 92
	br_striped     = 82
	wr_striped     = 107
	bg_striped     = 100
       = 1			: rem Colour_pal
	Black	       = 0
	White	       = 1
	Red	       = 2
	Green	       = 3
	Blue	       = 4
	Magenta        = 5
	Yellow	       = 6
	Cyan	       = 7
	Dark_slate     = 8
	Slate_grey     = 9
	Dark_grey      = 10
	Grey	       = 11
	Light_grey     = 12
	Ash_grey       = 13
	Dark_red       = 14
	Light_green    = 15
	Mustard        = 16
	Dark_green     = 17
	Sea_blue       = 18
	Dark_blue      = 19
	Purple	       = 20
	Shocking_pink  = 21
	Orange	       = 22
	Lime_green     = 23
	Apple_green    = 24
	Bright_blue    = 25
	Mauve	       = 26
	Peach	       = 27
	Light_yellow   = 28
	Light_blue     = 29
	Sky_blue       = 30
	Rose_pink      = 31
	Pink	       = 32
	Beige	       = 33
	Pastel_pink    = 34
	Pastel_yellow  = 35
	Pastel_green   = 36
	Pastel_cyan    = 37
	Pastel_blue    = 38
	Pastel_rose    = 39
	Brick	       = 40
	Light_khaki    = 41
	Dull_green     = 42
	Dull_cyan      = 43
	Steel_blue     = 44
	Dull_pink      = 45
	Brown	       = 46
	Khaki	       = 47
	Dusky_green    = 48
	Dusky_blue     = 49
	Midnight_blue  = 50
	Plum	       = 51
	Dusky_pink     = 52
	Buff	       = 53
	Avocado        = 54
	Dull_turquoise = 55
	Dull_blue      = 56
	Faded_purple   = 57
	Cerise	       = 58
	Tan_normal     = 59
	Grass_green    = 60
	Sea_green      = 61
	Ultramarine    = 62
	Deep_purple    = 63
	pinkish        = 77
	light_red      = 109
	Light_orange   = 208
	wg_striped     = light_green
	br_striped     = dark_red
	wr_striped     = light_red
	bg_striped     = dark_green
       = 2			: rem colour_24
	Black	       = hex('000000')
	White	       = hex('FFFFFF')
	Red	       = hex('FF0000')
	Green	       = hex('00FF00')
	Blue	       = hex('0000FF')
	Magenta        = hex('FF00FF')
	Yellow	       = hex('FFFF00')
	Cyan	       = hex('00FFFF')
	Dark_slate     = hex('242424')
	Slate_grey     = hex('494949')
	Dark_grey      = hex('6D6D6D')
	Grey	       = hex('929292')
	Light_grey     = hex('B6B6B6')
	Ash_grey       = hex('DBDBDB')
	Dark_red       = hex('920000')
	Light_green    = hex('B6FFB6')
	Mustard        = hex('929200')
	Dark_green     = hex('009200')
	Sea_blue       = hex('009292')
	Dark_blue      = hex('000092')
	Purple	       = hex('920092')
	Shocking_pink  = hex('FF0092')
	Orange	       = hex('FF9200')
	Lime_green     = hex('92FF00')
	Apple_green    = hex('00FF92')
	Bright_blue    = hex('0092FF')
	Mauve	       = hex('9200FF')
	Peach	       = hex('FFB6B6')
	Light_yellow   = hex('FFFFB6')
	Light_blue     = hex('B6FFFF')
	Sky_blue       = hex('B6B6FF')
	Rose_pink      = hex('FFB6FF')
	Pink	       = hex('FFB6DB')
	Beige	       = hex('FFDBB6')
	Pastel_pink    = hex('FFDBDB')
	Pastel_yellow  = hex('FFFFDB')
	Pastel_green   = hex('DBFFDB')
	Pastel_cyan    = hex('DBFFFF')
	Pastel_blue    = hex('DBDBFF')
	Pastel_rose    = hex('FFDBFF')
	Brick	       = hex('B66D6D')
	Light_khaki    = hex('B6B66D')
	Dull_green     = hex('6DB66D')
	Dull_cyan      = hex('6DB6B6')
	Steel_blue     = hex('6D6DB6')
	Dull_pink      = hex('B66DB6')
	Brown	       = hex('6D2424')
	Khaki	       = hex('6D6D24')
	Dusky_green    = hex('246D24')
	Dusky_blue     = hex('246D6D')
	Midnight_blue  = hex('24246D')
	Plum	       = hex('6D246D')
	Dusky_pink     = hex('B64992')
	Buff	       = hex('B69249')
	Avocado        = hex('92B649')
	Dull_turquoise = hex('49B692')
	Dull_blue      = hex('4992B6')
	Faded_purple   = hex('9249B6')
	Cerise	       = hex('920049')
	Tan_normal     = hex('924900')
	Grass_green    = hex('499200')
	Sea_green      = hex('009249')
	Ultramarine    = hex('004992')
	Deep_purple    = hex('490092')
	Light_orange   = hex('ffb624')
	pinkish        = hex('C0037B')
	Light_red      = hex('FC1729')
	wg_striped     = light_green
	br_striped     = dark_red
	wr_striped     = light_red
	bg_striped     = dark_green
  end select
  mode%=rmode
  ret mode%			: rem return current screen mode now
end def set_colours%
:
